                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                    pool                     */
                     /*---------------------------------------------*/

/*------------------------------------ public types ------------------------------------*/

typedef
  enum { Pool_And              =  0,
         Pool_Begin            =  1,
         Pool_Cond             =  2,
         Pool_Cons_Stream      =  3,
         Pool_Define           =  4,
         Pool_Delay            =  5,
         Pool_Else             =  6,
         Pool_Eval             =  7,
         Pool_If               =  8,
         Pool_Lambda           =  9,
         Pool_Let              = 10,
         Pool_Load             = 11,
         Pool_Macro            = 12,
         Pool_Or               = 13,
         Pool_Quasiquote       = 14,
         Pool_Quasisymbol      = 15,
         Pool_Quote            = 16,
         Pool_Set              = 17,
         Pool_Unquote          = 18,
         Pool_Unquote_Splicing = 19,
         Pool_While            = 20,
         Pool_Anonymous        = 21,
         Pool_Application      = 22,
         Pool_Expression       = 23,
         Pool_Sequence         = 24 } KEY_type;

/*---------------------------------- public prototypes ---------------------------------*/

SYM_type    Pool_Enter_Native_M(TXT_type);
SYM_type      Pool_Enter_Text_M(TXT_type);
SYM_type        Pool_Generate_M(SYM_type,
                                UNS_type);
SYM_type    Pool_Keyword_Symbol(KEY_type);
PAI_type       Pool_Quotation_M(KEY_type,
                                EXP_type);
BLN_type   Pool_Validate_Symbol(SYM_type);

/*------------------------------------- initialize -------------------------------------*/

VOI_type      Pool_Initialize_M(VOI_type);

