                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                    memory                   */
                     /*---------------------------------------------*/

/*---------------------------------- public constants ----------------------------------*/

enum { Memory_Cell_Width         = 0x00000004u,
       Memory_Maximum_Chunk_Size = 0x00FFFFFFu,
       Memory_Maximum_Smallint   = 0x3FFFFFFFu,
       Memory_Undefined_Value    = 0x00000000u };

/*------------------------------------ opaque types ------------------------------------*/

typedef union CEL * PTR_type;

/*------------------------------------ public types ------------------------------------*/

typedef PTR_type  * REF_type;

/*-------------------------------- callback prototypes ---------------------------------*/

VOI_type          Memory_Fail(VOI_type);

/*--------------------------------- public prototypes ----------------------------------*/

UNS_type     Memory_Available(VOI_type);
PTR_type       Memory_Chunk_M(UNS_type,
                              UNS_type);
VOI_type     Memory_Collect_C(VOI_type);
UNS_type    Memory_Get_Inline(PTR_type);
UNS_type Memory_Get_Qualifier(PTR_type);
UNS_type      Memory_Get_Size(PTR_type);
SGN_type  Memory_Get_Smallint(PTR_type);
UNS_type       Memory_Get_Tag(PTR_type);
VOI_type     Memory_Increment(REF_type);
PTR_type        Memory_Inline(UNS_type,
                              UNS_type);
UNS_type     Memory_Is_Inline(PTR_type);
UNS_type       Memory_Is_Pair(PTR_type);
UNS_type   Memory_Is_Smallint(PTR_type);
PTR_type        Memory_Pair_M(VOI_type);
PTR_type   Memory_Raw_Chunk_M(UNS_type,
                              UNS_type);
VOI_type      Memory_Register(ADR_type);
VOI_type       Memory_Replace(PTR_type,
                              PTR_type);
VOI_type       Memory_Set_Tag(PTR_type,
                              UNS_type);
PTR_type      Memory_Smallint(SGN_type);

/*------------------------------------- initialize -------------------------------------*/

VOI_type    Memory_Initialize(VOI_type);

