                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                     scan                    */
                     /*---------------------------------------------*/

/*------------------------------------ public types ------------------------------------*/

typedef
  enum { CHA_token,                                               /* character          */
         EOI_token,                                               /* end of input       */
         FLS_token,                                               /* false              */
         INT_token,                                               /* integer            */
         LPR_token,                                               /* left parenthesis   */
         PER_token,                                               /* period             */
         QQU_token,                                               /* quasiquote         */
         QSY_token,                                               /* quasisymbol        */
         QUO_token,                                               /* quote              */
         REA_token,                                               /* real               */
         RPR_token,                                               /* right parenthesis  */
         STR_token,                                               /* string             */
         SYM_token,                                               /* symbol             */
         TRU_token,                                               /* true               */
         UNQ_token,                                               /* unquote            */
         UQS_token,                                               /* unquote splicing   */
         VEC_token } TKN_type;                                    /* vector             */

/*---------------------------------- public variables ----------------------------------*/

extern CHR_type Scan_Text[];

/*---------------------------------- public prototypes ---------------------------------*/

TKN_type Scan_Input_Port(ADR_type);
TKN_type      Scan_Token(VOI_type);
TKN_type     Scan_String(TXT_type);

/*------------------------------------- initialize -------------------------------------*/

VOI_type Scan_Initialize(VOI_type);

